<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2012                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_load_average extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_load_average';
        $this->info['title']            = 'Защита от перегрузок';
        $this->info['description']      = 'При большой нагрузке на сервере приостанавливает работу сайта';
        $this->info['author']           = 'InstantCMS Team';
        $this->info['version']          = '1.0';

        // Настройки по-умолчанию
        $this->config['Порог нагрузки в процентах'] = 90;
        $this->config['Датчик: 1, 5 или 15 минут, соответственно значения 0, 1 или 2'] = 2;
        $this->config['При превышении показывать ошибку, отсылать emai или все вместе: 0, 1 или 2'] = 1;
        $this->config['Email для уведомлений'] = '';
        $this->config['Флаг блокировки отправления email (после исправлений ситуаций выставьте в 0)'] = 0;

        // События, которые будут отлавливаться плагином
        $this->events[]                 = 'GET_INDEX';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    public function execute($event, $val){

        parent::execute();

        $inCore = cmsCore::getInstance();

        if(!function_exists('sys_getloadavg')){ return true; }

        $la = sys_getloadavg();

        $threshold = round(100*$la[(int)$this->config['Датчик: 1, 5 или 15 минут, соответственно значения 0, 1 или 2']]);

        if($threshold >= $this->config['Порог нагрузки в процентах']){

            switch ($this->config['При превышении показывать ошибку, отсылать emai или все вместе: 0, 1 или 2']) {

                case 0:
                    cmsPage::includeTemplateFile('special/temporary_unavailable.php'); cmsCore::halt();
                    break;

                case 1:
                    if($this->config['Email для уведомлений'] &&
                            $this->config['Флаг блокировки отправления email (после исправлений ситуаций выставьте в 0)']){

                        $inCore->mailText($this->config['Email для уведомлений'],
                                'ВНИМАНИЕ! Большая нагрузка на сервер! - '.cmsConfig::getConfig('sitename'),
                                'На сайте "'.cmsConfig::getConfig('sitename').'" большая нагрузка, примите меры.');
                        // Блокируем для повторной отправки писем
                        $this->config['Флаг блокировки отправления email (после исправлений ситуаций выставьте в 0)'] = 1;
                        $inCore->savePluginConfig('p_load_average', $this->config);

                    } else {
                        cmsPage::includeTemplateFile('special/temporary_unavailable.php'); cmsCore::halt();
                    }
                    break;

                case 2:

                    if($this->config['Email для уведомлений'] &&
                            $this->config['Флаг блокировки отправления email (после исправлений ситуаций выставьте в 0)']){

                        $inCore->mailText($this->config['Email для уведомлений'],
                                'ВНИМАНИЕ! Большая нагрузка на сервер! - '.cmsConfig::getConfig('sitename'),
                                'На сайте "'.cmsConfig::getConfig('sitename').'" большая нагрузка, примите меры.');
                        // Блокируем для повторной отправки писем
                        $this->config['Флаг блокировки отправления email (после исправлений ситуаций выставьте в 0)'] = 1;
                        $inCore->savePluginConfig('p_load_average', $this->config);

                    }

                    cmsPage::includeTemplateFile('special/temporary_unavailable.php'); cmsCore::halt();
                    break;

                default: cmsPage::includeTemplateFile('special/temporary_unavailable.php'); cmsCore::halt();
                    break;

            }

        }

        return true;

    }

// ==================================================================== //

}

?>
